Package ru.bitel.bgbilling.plugins.bonus.server.bean

# Class OperationBonusProgram

java.lang.Object
ru.bitel.bgbilling.plugins.bonus.server.bean.OperationBonusProgram

All Implemented Interfaces:
  `BonusProgramSpecification`

public class OperationBonusProgram extends Object implements BonusProgramSpecification

- ## Constructor Summary

  Constructors
  Constructor
  Description
  `OperationBonusProgram()`

- ## Method Summary

  Modifier and Type
  Method
  Description
  `void`
  `accrualOfBonus(Connection con, BonusProgram program)`
  Начисление бонусов.
  `BigDecimal`
  `getBonusSumAccrual(BonusProgram program, BigDecimal allSum)`
  `Period`
  `getPeriod(BonusProgram program)`
  `Period`
  `getPeriodForBonusPayment(BonusProgram program)`
  `BigDecimal`
  `getSumOperationForPeriod(int cid, BonusProgram program, Period period)`
  `String`
  `getTitle()`

  ### Methods inherited from class java.lang.Object

  `clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

- ## Constructor Details

  - ### OperationBonusProgram

    public OperationBonusProgram()

- ## Method Details

  - ### getTitle

    public String getTitle()
    Specified by:
      `getTitle` in interface `BonusProgramSpecification`
    Returns:
      название типа бонусной программы.

  - ### accrualOfBonus

    public void accrualOfBonus(Connection con, BonusProgram program) throws Exception
    Description copied from interface: `BonusProgramSpecification`
    Начисление бонусов. Каждая программа берет на себя начисление бонусов для всех договоров и защищается от возможного двойного начисления( для этого есть таблица bonus_program_log ). Запуск производится планировщиком задач.
    Specified by:
      `accrualOfBonus` in interface `BonusProgramSpecification`
    Parameters:
      `con` -
      `program` - бонус. программа в которой содержатся параметры программы и т.д.
    Throws:
      `Exception`

  - ### getPeriod

    public Period getPeriod(BonusProgram program) throws Exception
    Returns:
      период за которой производится начисление бонусов.
    Throws:
      `Exception`

  - ### getPeriodForBonusPayment

    public Period getPeriodForBonusPayment(BonusProgram program)
    Parameters:
      `program` - - бонусная программа.
    Returns:
      активый период для бонусного платежа.

  - ### getBonusSumAccrual

    public BigDecimal getBonusSumAccrual(BonusProgram program, BigDecimal allSum)
    Returns:
      - вернет сумму бонусов к зачисления(метод как для шедулера так и для pluginServerListener ).

  - ### getSumOperationForPeriod

    public BigDecimal getSumOperationForPeriod(int cid, BonusProgram program, Period period) throws Exception
    Throws:
      `Exception`